
//!windows.h   C++Builder


class Texture
{
  public:
    GLuint texid;
    void Load(char *file_name, bool transparent = false);
    ~Texture() { glDeleteTextures(1, &texid); };
};

void Texture::Load(char *file_name, bool transparent)
{
  using namespace std;
  FILE *file=fopen(file_name, "rb");
  if (file==0)
    throw file_name;
  BITMAPFILEHEADER bfh;
  BITMAPINFOHEADER bih;
  fread(&bfh, sizeof(bfh), 1, file);
  fread(&bih, sizeof(bih), 1, file);
  if (bih.biBitCount!=24)
    throw "support only 24-bit files";
  int width = bih.biWidth;
  int height = bih.biWidth;
  unsigned int j;
  j=width;  while (!(1&j)) j>>=1; if (1!=j) throw ("width of bitmap is not 2^n");
  j=height; while (!(1&j)) j>>=1; if (1!=j) throw ("height of bitmap is not 2^n");
  char *data;
  if (!transparent)
    data=new GLubyte[3*width*height];
  else
    data=new GLubyte[4*width*height];
  fread(data, 1, width*height*3, file);
  for (int i=0; i<width*height; i++) {
    GLubyte t;
    t=data[i*3];
    data[i*3]=data[i*3+2];
    data[i*3+2]=t;
  }
  glGenTextures(1, &texid);
  glBindTexture(GL_TEXTURE_2D, texid);
  if (transparent) {
    for (int i=width*height-1; i>=0; i--) {
      if (
        (data[i*4+2]=data[i*3+2]) |
        (data[i*4+1]=data[i*3+1]) |
        (data[i*4+0]=data[i*3+0])
      )
        data[i*4+3]=255;
      else
        data[i*4+3]=0;
    }
    gluBuild2DMipmaps(
      GL_TEXTURE_2D,
      4,
      width,
      height,
      GL_RGBA,
      GL_UNSIGNED_BYTE,
      data
    );
  } else {
    gluBuild2DMipmaps(
      GL_TEXTURE_2D,
      3,
      width,
      height,
      GL_RGB,
      GL_UNSIGNED_BYTE,
      data
    );
  }
  delete[] data;
  fclose(file);
}







